diff -uNrd ircd-ratbox-1.3-1/modules/m_svsjoin.c ircd-1.4-FreedomBG/modules/m_svsjoin.c
--- ircd-ratbox-1.3-1/modules/m_svsjoin.c	Wed Dec 31 19:00:00 1969
+++ ircd-1.4-FreedomBG/modules/m_svsjoin.c	Thu May 13 19:44:29 2004
@@ -0,0 +1,418 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_svsjoin.c: Joins a channel via admin or service CMD.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svsjoin.c,v 1.4 2005/05/20 21:10:12 castello Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "common.h"
+#include "resv.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_serv.h"
+#include "s_conf.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "sprintf_irc.h"
+#include "packet.h"
+
+static void m_svsjoin(struct Client *, struct Client *, int, char **);
+
+struct Message svsjoin_msgtab = {
+	"SVSJOIN", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_svsjoin, m_svsjoin, m_svsjoin}
+};
+
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+	mod_add_cmd(&svsjoin_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svsjoin_msgtab);
+}
+const char *_version = "$Revision: 1.4 2004/01/23 $";
+
+#endif
+static void do_join_0(struct Client *client_p, struct Client *source_p);
+void check_spambot_warning(struct Client *source_p, const char *name);
+
+
+/*
+ * m_svsjoin
+ *      parv[0] = sender prefix
+ *      parv[1] = destination nickname
+ *      parv[2] = channel(s) to join
+ *	parv[3] = password (key)
+ */
+static void
+m_svsjoin(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	static char jbuf[BUFSIZE];
+	struct Channel *chptr = NULL;
+	struct Client *dest_p = NULL;
+	struct ResvEntry *resv;
+	char *name, *key = NULL;
+	int i, flags = 0;
+	char *p = NULL, *p2 = NULL;
+	int successful_join_count = 0;	/* Number of channels successfully joined */
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+		sendto_one(source_p, form_str(ERR_RESTRICTED), me.name, source_p->name);
+		return;
+	
+	}
+
+	if(EmptyString(parv[1]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSJOIN");
+		return;
+	}
+
+	if(EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSJOIN");
+		return;
+	}
+
+	if(!(dest_p = find_client(parv[1])))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+		return;
+
+	}
+
+	if(MyClient(dest_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Local SVSJOIN from %s for %s/%s", parv[0],
+				     parv[1], parv[2]);
+
+		*jbuf = '\0';
+
+		/* rebuild the list of channels theyre supposed to be joining.
+		 * this code has a side effect of losing keys, but..
+		 */
+		for (i = 0, name = strtoken(&p, parv[2], ","); name;
+		     name = strtoken(&p, (char *) NULL, ","))
+		{
+			/* check the length and name of channel is ok */
+			if(!check_channel_name(name) || (strlen(name) > CHANNELLEN))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, (unsigned char *) name);
+				continue;
+			}
+
+			if(*name == '0' && !atoi(name))
+			{
+				(void) strcpy(jbuf, "0");
+				continue;
+			}
+
+			/* check it begins with # or & */
+			else if(!IsChannelName(name) ||
+				(ConfigServerHide.disable_local_channels && (*name == '&')))
+			{
+				sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			/* see if its resv'd */
+			if(((resv = hash_find_resv(name)) != NULL)
+			   && (!IsOper(dest_p) || !ConfigChannel.no_oper_resvs))
+			{
+				sendto_one(source_p, form_str(ERR_BADCHANNAME),
+					   me.name, source_p->name, name);
+				sendto_realops_flags(UMODE_SPY, L_ALL,
+						     "User %s (%s@%s) was forced to join locally juped channel %s (%s)",
+						     dest_p->name, dest_p->username, dest_p->host,
+						     name, resv->reason);
+				continue;
+			}
+
+			if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+			   ConfigChannel.no_join_on_split)
+			{
+				sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+					   me.name, source_p->name, name);
+				continue;
+			}
+
+			if(*jbuf)
+				(void) strcat(jbuf, ",");
+			(void) strlcat(jbuf, name, sizeof(jbuf) - i - 1);
+			i += strlen(name) + 1;
+		}
+
+		if(parc > 3)
+		{
+			key = strtoken(&p2, parv[3], ",");
+		}
+
+		for (name = strtoken(&p, jbuf, ","); name;
+		     key = (key) ? strtoken(&p2, NULL, ",") : NULL, name = strtoken(&p, NULL, ","))
+		{
+			/* JOIN 0 simply parts all channels the user is in */
+			if(*name == '0' && !atoi(name))
+			{
+				if(!IsServer(source_p))
+				{
+					if(dest_p->user->channel.head == NULL)
+						continue;
+
+					do_join_0(&me, dest_p);
+				}
+				else
+				{
+					sendto_wallops_flags(UMODE_WALLOP, &me,
+							     "SVSJOIN from %s for %s on channel %s REJECTED!",
+							     parv[0], parv[1], parv[2]);
+				}
+				continue;
+			}
+
+			/* look for the channel */
+			if((chptr = hash_find_channel(name)) != NULL)
+			{
+				if(IsMember(dest_p, chptr))
+					continue;
+
+				if(dlink_list_length(&chptr->members) == 0)
+					flags = CHFL_CHANOP;
+				else
+					flags = 0;
+			}
+			else
+			{
+				if(splitmode && !IsOper(dest_p) && (*name != '&') &&
+				   ConfigChannel.no_create_on_split)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+						   me.name, source_p->name, name);
+					continue;
+				}
+
+				flags = CHFL_CHANOP;
+			}
+
+			if((dlink_list_length(&dest_p->user->channel) >=
+			    ConfigChannel.max_chans_per_user) && (!IsOper(dest_p)
+								  ||
+								  (dlink_list_length
+								   (&dest_p->user->channel) >=
+								   ConfigChannel.
+								   max_chans_per_user * 3)))
+			{
+				sendto_one(source_p, form_str(ERR_TOOMANYCHANNELS), me.name,
+					   parv[0], name);
+				if(successful_join_count)
+					dest_p->localClient->last_join_time = CurrentTime;
+				return;
+			}
+
+			if(flags == 0)	/* if channel doesn't exist, don't penalize */
+				successful_join_count++;
+
+			if(chptr == NULL)	/* If I already have a chptr, no point doing this */
+			{
+				chptr = get_or_create_channel(dest_p, name, NULL);
+
+				if(chptr == NULL)
+				{
+					sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE), me.name,
+						   parv[0], name);
+					if(successful_join_count > 0)
+						successful_join_count--;
+					continue;
+				}
+			}
+
+
+			if(!IsOper(dest_p) && !IsExemptSpambot(dest_p))
+				check_spambot_warning(dest_p, name);
+
+			/* can_join checks for +i key, bans etc */
+			if((i = can_join(dest_p, chptr, key)))
+			{
+				sendto_one(source_p, form_str(i), me.name, parv[1], name);
+				if(successful_join_count > 0)
+					successful_join_count--;
+				continue;
+			}
+
+			/* add the user to the channel */
+			add_user_to_channel(chptr, dest_p, flags);
+
+			/* we send the user their join here, because we could have to
+			 * send a mode out next.
+			 */
+			sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+					     dest_p->name,
+					     dest_p->username, dest_p->host, chptr->chname);
+
+			/* if theyre joining opped (ie, new chan or joining one thats
+			 * persisting) then set timestamp to current, set +nt and
+			 * broadcast the sjoin with its old modes, or +nt.
+			 */
+			if(flags & CHFL_CHANOP)
+			{
+				char mbuf[MODEBUFLEN];
+				char pbuf[MODEBUFLEN];
+
+				chptr->channelts = CurrentTime;
+				chptr->mode.mode |= MODE_TOPICLIMIT;
+				chptr->mode.mode |= MODE_NOPRIVMSGS;
+
+				sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +nt",
+						     me.name, chptr->chname);
+
+				if(*chptr->chname == '#')
+				{
+					channel_modes(chptr, dest_p, mbuf, pbuf);
+
+					strlcat(mbuf, " ", sizeof(mbuf));
+
+					if(pbuf[0] != '\0')
+						strlcat(mbuf, pbuf, sizeof(mbuf));
+
+					/* note: mbuf here will have a trailing space.  we add one above,
+					 * and channel_modes() will leave a trailing space on pbuf if
+					 * its used --fl
+					 */
+					sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+						      ":%s SJOIN %lu %s %s:@%s",
+						      me.name, (unsigned long) chptr->channelts,
+						      chptr->chname, mbuf, parv[1]);
+				}
+
+				/* drop our +beI modes */
+				free_channel_list(&chptr->banlist);
+				free_channel_list(&chptr->exceptlist);
+				free_channel_list(&chptr->invexlist);
+
+				/* REMOVE THIS AND DIE --fl */
+				chptr->num_mask = 0;
+			}
+			else
+			{
+				sendto_server(&me/*client_p*/, chptr, NOCAPS, NOCAPS,
+					      ":%s SJOIN %lu %s + :%s",
+					      me.name, (unsigned long) chptr->channelts,
+					      chptr->chname, parv[1]);
+			}
+
+			del_invite(chptr, dest_p);
+
+			if(chptr->topic != NULL)
+			{
+				sendto_one(dest_p, form_str(RPL_TOPIC), me.name,
+					   parv[1], chptr->chname, chptr->topic);
+
+				if(!(chptr->mode.mode & MODE_HIDEOPS) || (flags & CHFL_CHANOP))
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   chptr->topic_info, chptr->topic_time);
+				}
+				else	/* Hide from nonops */
+				{
+					sendto_one(dest_p, form_str(RPL_TOPICWHOTIME),
+						   me.name, parv[1], chptr->chname,
+						   me.name, chptr->topic_time);
+				}
+			}
+
+			channel_member_names(chptr, dest_p, 1);
+
+			if(successful_join_count)
+				source_p->localClient->last_join_time = CurrentTime;
+		}
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "Remote SVSJOIN from %s for %s/%s. Okay, forwarding message...",
+				     parv[0], parv[1], parv[2]);
+
+		if(parc >= 4)
+			sendto_one(dest_p->servptr, ":%s SVSJOIN %s %s %s", me.name,
+				   parv[1], parv[2], parv[3]);
+		else
+			sendto_one(dest_p->servptr, ":%s SVSJOIN %s %s", me.name, parv[1], parv[2]);
+	}
+}
+
+/*
+ * do_join_0
+ *
+ * inputs	- pointer to client doing join 0
+ * output	- NONE
+ * side effects	- Use has decided to join 0. This is legacy
+ *		  from the days when channels were numbers not names. *sigh*
+ *		  There is a bunch of evilness necessary here due to
+ * 		  anti spambot code.
+ */
+
+static void
+do_join_0(struct Client *client_p, struct Client *source_p)
+{
+	struct Channel *chptr = NULL;
+	struct membership *msptr;
+	dlink_node *lp;
+
+	/* Finish the flood grace period... */
+	if(MyClient(source_p) && !IsFloodDone(source_p))
+		flood_endgrace(source_p);
+
+
+	sendto_server(client_p, NULL, NOCAPS, NOCAPS, ":%s JOIN 0", source_p->name);
+
+	if(source_p->user->channel.head && MyConnect(source_p) &&
+	   !IsOper(source_p) && !IsExemptSpambot(source_p))
+		check_spambot_warning(source_p, NULL);
+
+	while ((lp = source_p->user->channel.head))
+	{
+		msptr = lp->data;
+		chptr = msptr->chptr;
+		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname);
+		remove_user_from_channel(msptr);
+	}
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_svsnick.c ircd-1.4-FreedomBG/modules/m_svsnick.c
--- ircd-ratbox-1.3-1/modules/m_svsnick.c	Wed Dec 31 19:00:00 1969
+++ ircd-1.4-FreedomBG/modules/m_svsnick.c	Thu May 13 19:44:16 2004
@@ -0,0 +1,212 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_svsnick.c: Sets a users nick to random one when the nickname is
+ *               registered and user did not identify within 30 seconds.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svsnick.c,v 1.3 2004/05/21 10:06:00 castello Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"
+#include "fdlist.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_stats.h"
+#include "s_user.h"
+#include "hash.h"
+#include "whowas.h"
+#include "s_serv.h"
+#include "send.h"
+#include "channel.h"
+#include "s_log.h"
+#include "resv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "common.h"
+#include "packet.h"
+
+
+static void m_svsnick(struct Client *, struct Client *, int, char **);
+
+static int check_clean_nick(struct Client *, struct Client *, char *, char *, char *);
+static int clean_nick_name(char *);
+
+struct Message svsnick_msgtab = {
+	"SVSNICK", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_ignore, m_svsnick, m_svsnick, m_svsnick}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svsnick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svsnick_msgtab);
+}
+
+const char *_version = "$Revision: 1.1 $";
+#endif
+
+/*
+ * m_svsnick()
+ *
+ *     parv[0] = sender prefix
+ *     parv[1] = target nickname
+ *     parv[2] = new nickname
+ */
+static void
+m_svsnick(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	char nick[NICKLEN];
+	struct Client *target_p;
+	struct Client *dest_p;
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+	    return;
+	}
+	
+	if(parc < 3 || BadPtr(parv[2]))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "No nickname given via SVSNICK from %s for %s", parv[0], parv[1]);
+		return;
+	}
+
+	/* terminate nick to NICKLEN */
+	strlcpy(nick, parv[2], sizeof(nick));
+
+	/* check the nickname is ok */
+	if(!clean_nick_name(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Bogus nickname via SVSNICK from %s for %s : %s", parv[0], parv[1], parv[2]);
+      return;
+	}
+
+	if(find_nick_resv(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Unavailable nickname via SVSNICK from %s for %s : %s", parv[0], parv[1], parv[2]);
+		return;
+	}
+	
+	if(!(dest_p = find_client(parv[1]))) {
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Nickname (%s) not found via SVSNICK",parv[1]);
+		return;
+	}
+	if (MyClient(dest_p)) {
+    	    ilog(L_ALL,"SVSNICK LOCAL %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SVSNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+
+	    change_local_nick(&me, dest_p, nick);
+	    }
+	else {
+    	    ilog(L_ALL,"SVSNICK REMOTE %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SVSNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+	    sendto_one(dest_p->servptr,":%s SVSNICK %s %s", me.name,
+	                                      parv[1], nick);
+	}
+}
+/* 
+ * check_clean_nick()
+ * 
+ * input	- pointer to source
+ *		- nickname
+ *		- truncated nickname
+ *		- origin of client
+ * output	- none
+ * side effects - if nickname is erroneous, or a different length to
+ *                truncated nickname, return 1
+ */
+static int
+check_clean_nick(struct Client *client_p, struct Client *source_p,
+		 char *nick, char *newnick, char *server)
+{
+	/* the old code did some wacky stuff here, if the nick is invalid, kill it
+	 * and dont bother messing at all
+	 */
+
+	/*
+	 * Zero length nicks are bad too..this shouldn't happen but..
+	 */
+
+	if(!clean_nick_name(nick) || strcmp(nick, newnick) || nick[0] == '\0')
+	{
+		ServerStats->is_kill++;
+		sendto_realops_flags(UMODE_DEBUG, L_ALL,
+				     "Bad Nick: %s From: %s(via %s)", nick, server, client_p->name);
+
+		sendto_one(client_p, ":%s KILL %s :%s (Bad Nickname)", me.name, newnick, me.name);
+
+		/* bad nick change */
+		if(source_p != client_p)
+		{
+			kill_client_serv_butone(client_p, source_p, "%s (Bad Nickname)", me.name);
+			source_p->flags |= FLAGS_KILLED;
+			exit_client(client_p, source_p, &me, "Bad Nickname");
+		}
+
+		return 1;
+	}
+
+	return 0;
+}
+
+/* clean_nick_name()
+ *
+ * input	- nickname
+ * output	- none
+ * side effects - walks through the nickname, returning 0 if erroneous
+ */
+static int
+clean_nick_name(char *nick)
+{
+	assert(nick);
+	if(nick == NULL)
+		return 0;
+
+	/* nicks cant start with a digit or -, and must have a length */
+	if(*nick == '-' || IsDigit(*nick) || !*nick)
+		return 0;
+
+	for (; *nick; nick++)
+	{
+		if(!IsNickChar(*nick))
+			return 0;
+	}
+
+	return 1;
+}
+
diff -uNrd ircd-ratbox-1.3-1/modules/m_svspart.c ircd-1.4-FreedomBG/modules/m_svspart.c
--- ircd-ratbox-1.3-1/modules/m_svspart.c	Wed Dec 31 19:00:00 1969
+++ ircd-1.4-FreedomBG/modules/m_svspart.c	Thu May 13 19:45:13 2004
@@ -0,0 +1,204 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_part.c: Parts a user from a channel.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svspart.c,v 1.94 2005/05/17 12:24:12 castello Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "common.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "s_conf.h"
+#include "packet.h"
+
+static void m_svspart(struct Client *, struct Client *, int, char **);
+void check_spambot_warning(struct Client *source_p, const char *name);
+
+struct Message svspart_msgtab = {
+	"SVSPART", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_svspart, m_svspart, m_svspart}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svspart_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svspart_msgtab);
+}
+const char *_version = "$Revision: 1.1.8 $";
+#endif
+
+static void part_one_client(struct Client *client_p,
+			    struct Client *source_p, char *name, char *reason);
+
+
+/*
+** m_svspart
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = reason
+*/
+static void
+m_svspart(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	char *p, *name;
+	char reason[TOPICLEN + 1];
+	struct Client *dest_p = NULL;
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+		sendto_one(source_p, form_str(ERR_RESTRICTED), me.name, source_p->name);
+		return;
+	
+	}
+
+	if(EmptyString(parv[1]) || EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSPART");
+		return;
+	}
+	if(!IsServer(source_p) && !IsAdmin(source_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "DENIED ACCESS to SVSPART for %s !", source_p->name);
+		ilog(L_ALL, "DENIED ACCESS to SVSPART for %s !", source_p->name);
+		return;
+	}
+	if(!(dest_p = find_person(parv[1])))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+		return;
+	}
+
+	if(!MyClient(dest_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Forwarding SVSPART from %s for %s/%s",
+				     parv[0], parv[1], parv[2]);
+		ilog(L_ALL, "Forwarding SVSPART from %s for %s/%s", parv[0], parv[1], parv[2]);
+		sendto_one(dest_p->servptr, ":%s SVSPART %s %s %s", parv[0],
+			   parv[1], parv[2], (parv[3]) ? parv[3] : NULL);
+		return;
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Received SVSPART from %s for %s/%s",
+				     parv[0], parv[1], parv[2]);
+		ilog(L_ALL, "Received SVSPART from %s for %s/%s", parv[0], parv[1], parv[2]);
+	}
+
+	reason[0] = '\0';
+
+	if(parc > 3)
+		strlcpy(reason, parv[3], sizeof(reason));
+
+	name = strtoken(&p, parv[2], ",");
+
+	/* Finish the flood grace period... */
+	if(MyClient(dest_p) && !IsFloodDone(dest_p))
+		flood_endgrace(dest_p);
+
+	while (name)
+	{
+		part_one_client(client_p, dest_p, name, reason);
+		name = strtoken(&p, (char *) NULL, ",");
+	}
+	return;
+}
+
+/*
+ * part_one_client
+ *
+ * inputs	- pointer to server
+ * 		- pointer to source client to remove
+ *		- char pointer of name of channel to remove from
+ * output	- none
+ * side effects	- remove ONE client given the channel name 
+ */
+static void
+part_one_client(struct Client *client_p, struct Client *source_p, char *name, char *reason)
+{
+	struct Channel *chptr;
+	struct membership *msptr;
+
+	if((chptr = hash_find_channel(name)) == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name, source_p->name, name);
+		return;
+	}
+
+	msptr = find_channel_membership(chptr, source_p);
+	if(msptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, source_p->name, name);
+		return;
+	}
+	if(MyConnect(source_p) && !IsOper(source_p) && !IsExemptSpambot(source_p))
+		check_spambot_warning(source_p, NULL);
+
+	/*
+	 *  Remove user from the old channel (if any)
+	 *  only allow /part reasons in -m chans
+	 */
+	if(reason[0] && (is_chanop(msptr) || !MyConnect(source_p) ||
+			 ((can_send(chptr, source_p, msptr) > 0 &&
+			   (source_p->firsttime + ConfigFileEntry.anti_spam_exit_message_time)
+			   < CurrentTime))))
+	{
+		sendto_server(&me /* client_p */, chptr, NOCAPS, NOCAPS,
+			      ":%s PART %s :%s", source_p->name, chptr->chname, reason);
+
+		sendto_channel_local(ALL_MEMBERS,
+				     chptr, ":%s!%s@%s PART %s :%s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname, reason);
+	}
+	else
+	{
+		sendto_server(&me /* client_p */, chptr, NOCAPS, NOCAPS,
+			      ":%s PART %s", source_p->name, chptr->chname);
+
+		sendto_channel_local(ALL_MEMBERS,
+				     chptr, ":%s!%s@%s PART %s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname);
+	}
+	del_nokick_chan(source_p, name);
+	remove_user_from_channel(msptr);
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_users.c ircd-1.4-FreedomBG/modules/m_users.c
--- ircd-ratbox-1.3-1/modules/m_users.c	Thu Jun 26 10:02:15 2003
+++ ircd-1.4-FreedomBG/modules/m_users.c	Thu May 13 20:24:54 2004
@@ -80,6 +80,16 @@
 
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 		   Count.total, Count.max_tot);
+#ifdef FreedomBG
+	sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+		   CurrentIdentUsers, MaxIdentUsers);
+
+	sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+		   CurrentOSidUsers, MaxOSidUsers);
+
+	sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+		   CurrentGlinerUsers, MaxGlinerUsers);
+#endif
 }
 
 /*
@@ -101,5 +111,15 @@
 
 		sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 			   Count.total, Count.max_tot);
+#ifdef FreedomBG
+		sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+			   CurrentIdentUsers, MaxIdentUsers);
+
+		sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+			   CurrentOSidUsers, MaxOSidUsers);
+
+		sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+			   CurrentGlinerUsers, MaxGlinerUsers);
+#endif
 	}
 }
diff -uNrd ircd-ratbox-1.3-1/modules/m_whois.c ircd-1.4-FreedomBG/modules/m_whois.c
--- ircd-ratbox-1.3-1/modules/m_whois.c	Fri Nov 28 10:14:51 2003
+++ ircd-1.4-FreedomBG/modules/m_whois.c	Thu May 13 22:09:24 2004
@@ -271,7 +271,7 @@
 			   source_p->name, name,
 			   target_p->username, target_p->host, target_p->info);
 		sendto_one(source_p, form_str(RPL_WHOISSERVER),
-			   me.name, source_p->name, name, "<Unknown>", "*Not On This Net*");
+			   me.name, source_p->name, name, "<Unknown>", "*Not from FreedomBG*");
 		return;
 	}
 
@@ -282,6 +282,50 @@
 		   target_p->username, target_p->host, target_p->info);
 	server_name = (char *) target_p->user->server;
 
+#ifdef FreedomBG
+	if (IsNSId(target_p)) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+			   me.name, source_p->name, target_p->name,
+			   "NS","- registered and identified");
+	}
+
+    if (IsOSId(target_p)) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+ 	    me.name, source_p->name, target_p->name,
+			   "OS","- identified as Service and Network Administrator");
+	}
+
+    if (IsGLId(target_p)) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+ 	    me.name, source_p->name, target_p->name,
+			   "Gliner","- identified as NetKeeper and Developer");
+	}
+
+	if (HasSilence(target_p)) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+			   me.name, source_p->name, target_p->name,
+			   "(+S)","- is spam and abuse protected");
+	}
+	
+	if (target_p->umodes & UMODE_CALLERID) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+ 	    me.name, source_p->name, target_p->name,
+			   "(+g)","- is an IRC Maniac");
+	}
+
+	if (s_check(target_p->name)) {
+		sendto_one(source_p, form_str(RPL_WHOISSERVER),
+			   me.name, source_p->name, target_p->name,
+			   "NS","- registered and identified");
+/*	    sendto_one(source_p,form_str(RPL_WHOISCHANNELS), me.name, 
+		    source_p->name, target_p->name, "The Channel list is hidden"); */
+
+		ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name);
+		sendto_one(source_p, "%s%s", buf, "TOP Secret Place ! STOP /whois him !");
+
+	} else {
+#endif /* FreedomBG */
+
 	cur_len = mlen = ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name);
 	t = buf + mlen;
 
@@ -311,6 +355,9 @@
 
 	if(cur_len > mlen)
 		sendto_one(source_p, "%s", buf);
+#ifdef FreedomBG
+    }
+#endif
 
 	if((IsOper(source_p) || !ConfigServerHide.hide_servers) || target_p == source_p)
 		sendto_one(source_p, form_str(RPL_WHOISSERVER),
diff -uNrd ircd-ratbox-1.3-1/src/channel.c ircd-1.4-FreedomBG/src/channel.c
--- ircd-ratbox-1.3-1/src/channel.c	Fri Sep  5 20:03:09 2003
+++ ircd-1.4-FreedomBG/src/channel.c	Thu May 13 20:30:11 2004
@@ -800,6 +800,25 @@
 	   dlink_list_length(&chptr->members) >= chptr->mode.limit)
 		return (ERR_CHANNELISFULL);
 
+#ifdef FreedomBG
+	
+	if (chptr->mode.mode & MODE_ADMONLY)
+	{
+		if (!IsAdmin(source_p))
+		{
+			return (ERR_ADMINCHAN);
+		}
+	}
+
+	if (chptr->mode.mode & MODE_OPRONLY)
+	{
+		if (!IsOper(source_p))
+		{
+			return (ERR_OPERCHAN);
+		}
+	}
+#endif
+
 	return 0;
 }
 
